<?php
/* --------------------------------------------------------------
   dependent.inc.php 2019-10-16
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2019 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/
/** @var DatabaseModel $this */

if (method_exists($this, 'addAdminAccessGroup') && $this->table_exists('admin_access_groups')) {
    
    $check = $this->query('SELECT * FROM `admin_access_group_items` WHERE `type` = "CONTROLLER" AND `identifier` = "StyleEdit4Authentication"',
                          true);
    
    if ($check->num_rows < 1) {
        $t_success = false;
        
        $styleEditControllers       = [
            'StyleEdit4Authentication',
            'StyleEdit3Authentication',
            'StyleEditCategorySearch',
            'StyleEditProductSearch',
        ];
        $styleEditGroupNames        = [
            1 => 'StyleEdit',
            2 => 'StyleEdit',
        ];
        $styleEditGroupDescriptions = [
            1 => 'Allows the usage of StyleEdit3 and StyleEdit4',
            2 => 'Erlaubt die Nutzung von StyleEdit3 und StyleEdit4',
        ];
        
        $latestSortOrder = $this->query('SELECT `sort_order` FROM `admin_access_groups` ORDER BY `sort_order` DESC LIMIT 1');
        $sortOrder       = (int)$latestSortOrder['sort_order'] + 1;
        
        $insertedGroupId = $this->addAdminAccessGroup($styleEditGroupNames, $styleEditGroupDescriptions, $sortOrder);
        
        if ($insertedGroupId !== false) {
            
            $this->addAdminAccessGroupItem($insertedGroupId, 'CONTROLLER', $styleEditControllers);
            
            $adminAccessRoles = $this->query('SELECT `admin_access_role_id` FROM `admin_access_roles`;');
            
            if (is_array($adminAccessRoles)) {
                
                foreach ($adminAccessRoles as $adminAccessRole) {
                    
                    $roleId = $adminAccessRole['admin_access_role_id'];
                    
                    $this->grantAdminAccessPermission($roleId, $insertedGroupId);
                }
                
                $t_success = true;
            }
        }
    }
}
